/*
    NewTemplateCmd.h - template creation

    Will 18, 2001: will@opaline.demon.co.uk
*/

#ifndef NewTemplateCMD_H
#define NewTemplateCMD_H


#include <NoUndoCmd.h>

#ifndef BREAK
#define BREAK
#include <BreakCmd.h>
#endif


typedef void ( *sizeEnteredCallback ) ( void *, char * );
typedef void ( *sizeCancelledCallback ) ( void * );


class CreateTemplateFileCmd;
class LineEdit;
class DMenuCmd;
class FileSelect;


class NewTemplateCmd : public NoUndoCmd
{
	protected:
		void doCommand();	// NewTemplate
		
	public:
		NewTemplateCmd ( char *, int, int );
		virtual const char *const className() { return ( "NewTemplateCmd" ); }

	private:
		static void dMenuSelectionCallback ( void *, unsigned int, char * );
		static void sourceSelectedCallback ( void *, char * );
		static void sourceCancelledCallback ( void * );
		static void targetSelectedCallback ( void *, char * );
		static void targetCancelledCallback ( void * );

		// note 'ok' is mapped to 'enter' by TextEdit
		static void sizeEnteredCallback ( void *, char * );
		static void sizeCancelledCallback ( void * );

		static void createTemplateFinishedCallback ( BreakCmd *, Boolean, void * );
		void createTemplateFinished ( CreateTemplateFileCmd * );

		void newTemplate ( unsigned int );
		void sourceSelected ( char * );
		void createTemplate ( unsigned int );
		void createTemplateFile ( void );

		const char *_name;
		char *_filename;
		unsigned _arrayItems;	// num items on menu
		Boolean _menuRealised;
		Boolean _srcSel;
		Boolean _dstSel;
		LineEdit *_edit;
		DMenuCmd *_dMenu;
		FileSelect *_src, *_dst;
		int _dataType;		/* 0 = int, 1 = float */
		long _numSamples;
		unsigned int _waveNum;
};


#endif

