/*
    StopCmd.cc

    Will Eighteen: will@opaline.demon.co.uk
*/

#include "wave/waveclass.h"
#include "AppWindow.h"
#include "StopCmd.h"
#include "OpResources.h"
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <MessageDialogManager.h>
#include <FileAccess.h>


StopCmd::StopCmd ( const char *name, int active ) : NoUndoCmd ( name, active )
{
	// empty
}


void StopCmd::doCommand()
{
// this should be defined in resources!
	char buf[256];
	snprintf ( buf, sizeof ( buf ), "kill $(/sbin/pidof sox) 2>/dev/null" );
	buf [ sizeof ( buf ) - 1 ] = 0;
	sysCall ( buf );
}


int StopCmd::sysCall ( const char *command )
{	// code ripped from GNU 'system' man page
   int pid, status;

   if ( command == 0 )
       return 1;
	   
   pid = fork();
	
   if ( pid == -1 )
       return -1;
	   
   if ( pid == 0 )
   {
       char *argv[4];
       argv[0] = "sh";
       argv[1] = "-c";
       argv[2] = ( char * ) command;
       argv[3] = 0;
	   execve( "/bin/sh", argv, environ );
       exit ( 127 );
   }

   do
   {
		if ( waitpid ( pid, &status, 0 ) == -1 )
		{
           if ( errno != EINTR )
               return -1;
		}
		else
           return status;   
   } while ( 1 );
}
